unit DummyMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, ExtCtrls;

type
  TDummyMainForm = class(TForm)
    PopupMenu: TPopupMenu;
    MenuMisc: TMenuItem;
    MenuAbout: TMenuItem;
    MenuOpenStartup: TMenuItem;
    MenuCreateStartup: TMenuItem;
    MenuExit: TMenuItem;
    MenuOpenLauncher: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuOpenStartupClick(Sender: TObject);
    procedure MenuCreateStartupClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MenuOpenLauncherClick(Sender: TObject);
  private
    procedure TrayIconOnLeftClick(Sender: TObject);
    procedure TrayIconOnLeftDblClick(Sender: TObject);
    procedure TrayIconOnRightDblClick(Sender: TObject);
    procedure TrayIconOnRightClick(Sender: TObject);
    //procedure MessageOut(const Msg: string);
  public
  end;

var
  DummyMainForm: TDummyMainForm;

implementation

{$R *.dfm}

uses
    Info, iTray, ExeWatch, Launcher;

//-----------------------------------------------------------------------------
//  gCACRĂ΂郁\bh
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  NbN
procedure TDummyMainForm.TrayIconOnLeftClick(Sender: TObject);
begin
    //SetForegroundWindow(Handle);
    //SimpleTray.ShowBalloon('test', 'TrayIconOnLeftClick', bitINFO, mtBALLOON);
    MenuOpenLauncher.OnClick(MenuOpenLauncher);
end;
//-----------------------------------------------------------------------------
//  _uNbN
procedure TDummyMainForm.TrayIconOnLeftDblClick(Sender: TObject);
begin
    //SetForegroundWindow(Handle);
    //SimpleTray.ShowBalloon('test', 'TrayIconOnLeftDblClick', bitINFO, mtBALLOON);
end;
//-----------------------------------------------------------------------------
//  ENbN
procedure TDummyMainForm.TrayIconOnRightClick(Sender: TObject);
begin
    SetForegroundWindow(Handle);
    //  |bvAbvj[\
    PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;
//-----------------------------------------------------------------------------
//  E_uNbN
procedure TDummyMainForm.TrayIconOnRightDblClick(Sender: TObject);
begin
    //SetForegroundWindow(Handle);
    //SimpleTray.ShowBalloon('test', 'TrayIconOnRightDblClick', bitINFO, mtBALLOON);
end;

//-----------------------------------------------------------------------------
//  ^XNo[ɕ\Ȃ߂̃_~[CtH[
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TDummyMainForm.FormCreate(Sender: TObject);
var
    R: TRect;    
begin
    //  CtH[\
    Application.ShowMainForm := False;

    //  AvP[VEBhEB
    ShowWindow(Application.Handle, SW_HIDE);

    //  ^Ɉړ
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    Self.Left := (R.Right - R.Left - Self.Width) div 2;
    Self.Top := (R.Bottom - R.Top - Self.Height) div 2;

    //  gCACR\
    SimpleTray := TSimpleTaskTray.Create(Application.Icon.Handle);
    SimpleTray.FOnLeftClick     := TrayIconOnLeftClick;
    SimpleTray.FOnLeftDblClick  := TrayIconOnLeftDblClick;
    SimpleTray.FOnRightClick    := TrayIconOnRightClick;
    SimpleTray.FOnRightDblClick := TrayIconOnRightDblClick;
    SimpleTray.AddTray(ExtractFileName(ParamStr(0)));

    //  CBTtbNJn
    RecentApps := TRecentApps.Create();
    //RecentApps.MessageOut := MessageOut;
    RecentApps.Start();
end;

//-----------------------------------------------------------------------------
//  CBTtbNpNXĂ΂郁bZ[Wo͊֐(b)
//procedure TDummyMainForm.MessageOut(const Msg: string);
//begin
//    Memo1.Lines.Add(Msg);    
//end;

//-----------------------------------------------------------------------------
//  I
procedure TDummyMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
    //  CBTtbNI
    RecentApps.Stop();
    RecentApps.Free();

    //  gCACR~
    SimpleTray.Free();
end;

//-----------------------------------------------------------------------------
//  j[Cxgnh
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  ̃vOɂ
procedure TDummyMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  X^[gAbvJ
procedure TDummyMainForm.MenuOpenStartupClick(Sender: TObject);
begin
    SimpleShellExecute(GetStartUpFolderPath());
end;

//-----------------------------------------------------------------------------
//  X^[gAbvɓo^
procedure TDummyMainForm.MenuCreateStartupClick(Sender: TObject);
begin
    CreateStartup();
end;

//-----------------------------------------------------------------------------
//  AvP[VI
procedure TDummyMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

//-----------------------------------------------------------------------------
//  `[ʕ\
procedure TDummyMainForm.MenuOpenLauncherClick(Sender: TObject);
begin
    if (LauncherForm.Visible) then LauncherForm.Close(); 
    RecentApps.SnapShot(LauncherForm.FExeData);
    LauncherForm.Show();
end;

end.

